bug-gnulib
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

Re: [PATCH] file-has-acl: revert unintended change in behavior of ls -L


From: Jim Meyering
Subject: Re: [PATCH] file-has-acl: revert unintended change in behavior of ls -L
Date: Mon, 03 Oct 2011 13:51:39 +0200

Kamil Dudka wrote:

> On Mon October 3 2011 13:09:21 Jim Meyering wrote:
>> Kamil Dudka wrote:
>> > On Mon October 3 2011 12:45:01 Jim Meyering wrote:
>> >> Can you describe how to make "ls -L" misbehave without this patch?
>> >
>> > if you have a symlink to a file with ACL, 'ls -Ll' does not print the '+'
>> > at end of the column with permission bits.
>>
>> Thanks.  I expect to add something like this:
>>
>>     $ touch k; setfacl -m user:${USER}:r k; ln -s k s; env ls -Log s
>>     -rw-r-----. 1 0 Oct  3 13:07 s
>>
>> That "." is wrong.  It should be "+".
>
> I am having problems finding a good way to detect that ls is capable
> of detecting ACLs.  AFAIK there is no such macro in config.h.  The
> preprocessor games in lib/file-has-acl.c are overly complicated.
>
> What about the following scenario?
>
> 1. try ls -l directly on a regular file with ACL, check if it prints '+'.
> 2. if it succeeds, try the same on a regular file and a symbolic link
> with/without -L

Good point.  This should do it:

  touch k; setfacl -m user:${USER}:r k; ln -s k s
  set _ $(ls -Log s); shift; link=$1
  set _ $(ls -og k);  shift; reg=$1
  test "$link" = "$reg" || fail=1

>From 6b9751f0ffe276bc4fb9d30e38cc59ad92e7ca0e Mon Sep 17 00:00:00 2001
From: Jim Meyering <address@hidden>
Date: Mon, 3 Oct 2011 13:49:47 +0200
Subject: [PATCH] tests: add a test to exercise today's ls-lL-vs-ACL bug

* tests/ls/slink-acl: New file.
* tests/Makefile.am (TESTS): Add it.
* tests/init.cfg (require_setfacl_): New function.
See http://thread.gmane.org/gmane.comp.lib.gnulib.bugs/28538
---
 tests/Makefile.am  |    1 +
 tests/init.cfg     |    6 ++++++
 tests/ls/slink-acl |   33 +++++++++++++++++++++++++++++++++
 3 files changed, 40 insertions(+), 0 deletions(-)
 create mode 100755 tests/ls/slink-acl

diff --git a/tests/Makefile.am b/tests/Makefile.am
index 2cf409a..9c9a1b8 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -431,6 +431,7 @@ TESTS =                                             \
   ls/readdir-mountpoint-inode                  \
   ls/recursive                                 \
   ls/rt-1                                      \
+  ls/slink-acl                                 \
   ls/stat-dtype                                        \
   ls/stat-failed                               \
   ls/stat-free-color                           \
diff --git a/tests/init.cfg b/tests/init.cfg
index f6eb651..04abe4f 100644
--- a/tests/init.cfg
+++ b/tests/init.cfg
@@ -130,6 +130,12 @@ require_strace_()
     skip_ 'strace -qe "'"$1"'" does not work'
 }

+require_setfacl_()
+{
+  setfacl -m user::rwx . \
+    || skip_ "setfacl does not work on the current file system"
+}
+
 # Require a controlling input `terminal'.
 require_controlling_input_terminal_()
 {
diff --git a/tests/ls/slink-acl b/tests/ls/slink-acl
new file mode 100755
index 0000000..8594642
--- /dev/null
+++ b/tests/ls/slink-acl
@@ -0,0 +1,33 @@
+#!/bin/sh
+# verify that ls -lL works when applied to a symlink to an ACL'd file
+
+# Copyright (C) 2011 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/init.sh"; path_prepend_ ../src
+print_ver_ ls
+
+require_setacl_
+
+touch k || framework_failure_
+setfacl -m user:${USER}:r k || framework_failure_
+ln -s k s || framework_failure_
+
+set _ $(ls -Log s); shift; link=$1
+set _ $(ls -og k);  shift; reg=$1
+
+test "$link" = "$reg" || fail=1
+
+Exit $fail
--
1.7.7.rc0.362.g5a14



reply via email to

[Prev in Thread] Current Thread [Next in Thread]